#!/usr/bin/perl

# Inserts an ADFS ROM image into a DDOS-bootable ADFS disc image.
# Usage: perl bootpatch.pl DISKIMAGE ROMIMAGE FDCTYPE
#   where DISKIMAGE is a 180 KiB DDOS disk image
#         ROMIMAGE is a 16 KiB ADFS ROM image
#         FDCTYPE is the five-character code for the floppy drive
#                 controller supported by ROMIMAGE, one of
#                 O2791 O2793 U2793 O1770 CHALL W1770 A1770 S1770
#                 The ADFS version number is given as 1.33 in the
#                 special case of A1770, 1.39 otherwise.
# NB DISKIMAGE file edited in-place!
# Make a backup of DISKIMAGE before using.

open(IMG,"+<".$ARGV[0])or die;binmode(IMG);
open(ROM,"<".$ARGV[1])or die;binmode(IMG);
$name = uc($ARGV[2]);

seek(IMG,0x1fb,0);print IMG pack("v",rand(0x10000));
seek(IMG,0x100,0);die unless read(IMG,$fst,0xff)==0xff;
$sum = &adfs_sum($fst);
seek(IMG,0x1ff,0); # seek between read/write or write/read
print IMG pack("C",$sum);
foreach $ptr (0x74b,0x903,0x3426,0x7c4b) {
  seek(IMG,$ptr,0);
  if(substr($name,0,5) eq "A1770") {
    print IMG "3";
  } else {
    print IMG "9";
  }
}
seek(IMG,0x6e7,0); printf IMG "%-.5s",$name;
seek(IMG,0x800,0); printf IMG "%-.5s",$name;
for($segment=0; $segment<32; ++$segment) {
  die unless read(ROM,$seg,0x200)==0x200;
  seek(IMG,0xa000+$segment*0x1200,0);
  print IMG $seg;
}
close(ROM);
close(IMG);
exit(0);

sub adfs_sum ($) {
  my ($s) = @_;
  my $c = 0xff;
  my $i = 0xff;

  die unless length($s) == 255;
  do {
    --$i;
    $c -= 0xff if $c > 0xff;
    $c += unpack("C",substr($s,$i,1));
  } while($i);
  return($c & 0xff);
}

